// -*- mode: C++; coding: cp1251 -*-
//
//

#include "string.h"
#include <sstream>
#include <fstream>
#include "../log.h"
#include <iostream>
#include <stdio.h>
#include "../smtp.h"

#ifdef WIN32
#define strcasecmp _stricmp
#endif

std::string lp="";
std::string dm="";


void z1();
void z2(int code);
void z3(int code);
void z4();void z5();void z6();
void z7();void z8();void z9();
void z10();void z11();void z12();
void z13();void z14();void z15();
void z16();void z17();void z18();
void z19();void z20();void z21();


void A0(); void A1(); void A2(); void A3();

#ifdef WIN32
Logger ll("log.txt");
#else
Logger ll("/usr/local/smtp/log.txt");
#endif

void log_begin(int n, int state)
{
    ll.started(n,state);
}

void log_end(int n, int state)
{
    ll.finished(n,state);
}

void loginit()
{
    Auto A0(0);
    Auto A1(1);
    Auto A2(2);
    Auto A3(3);
    A0.add(Automate_var("x1",&x1));
    A0.add(Automate_var("e0",&e0));
    A0.add(Automate_var("e1",&e1));
    A0.add(Automate_var("e2",&e2));
    A0.add(Automate_var("e3",&e3));
    A0.add(State(1,"" ));
    A0.add(State(2,"  MAIL"));
    A0.add(State(3,"  RCPT"));
    A0.add(State(4," "));
    ll.add(A0);
    A1.add(Automate_var("x2",&x2));
    A1.add(Automate_var("x3",&x3));
    A1.add(Automate_var("x4",&x4));
    A1.add(Automate_var("x5",&x5));
    A1.add(Automate_var("x6",&x6));
    A1.add(Automate_var("x7",&x7));
    A1.add(State(1,"  " ));
    A1.add(State(2," "));
    A1.add(State(3," "));
    A1.add(State(4," "));
    A1.add(State(5," "));
    A1.add(State(6," "));
    A1.add(State(7,""));
    A1.add(State(8," "));
    ll.add(A1);
    A2.add(Automate_var("x2",&x2));
    A2.add(Automate_var("x7",&x7));
    A2.add(Automate_var("x8",&x8));
    A2.add(State(1," "));
    A2.add(State(2," "));
    A2.add(State(3," "));
    A2.add(State(4," "));
    A2.add(State(5,""));
    A2.add(State(6," "));
    A2.add(State(7,""));
    A2.add(State(8," "));
    ll.add(A2);
    A3.add(Automate_var("x9",&x9));
    A3.add(Automate_var("x10",&x10));
    A3.add(Automate_var("x11",&x11));
    A3.add(State(1," "));
    A3.add(State(2," <CR>"));
    A3.add(State(3," <CR><LF>"));
    A3.add(State(4," <CR><LF>."));
    A3.add(State(5," <CR><LF>.<CR>"));
    A3.add(State(6," "));
    ll.add(A3);
    //    ll.loglevel(LL_ACTIONS);
    ll.loglevel(LL_ACTIONS);
}

void log_inv_state(int n, int state)
{
    ll.inval_state(n,state);
}


void z1()
{
    ll.action(1,"    .");
}

std::string cmd="";
int pos;


void readnew()
{
    char buf[1024];
    std::cin.getline(buf,1024);
    while (!buf[0])
        std::cin.getline(buf,1024);
    x7=false;
    cmd=buf;
    x1=7;
    pos=0;
    x2=buf[0];
    if (cmd.length()<4)
        x1=7;
    std::string cmd_str=cmd.substr(0,4);
    const char* cmd = cmd_str.c_str();
    if (!strcasecmp(cmd,"helo")) x1=0;
    else if (!strcasecmp(cmd,"mail")) x1=1;
    else if (!strcasecmp(cmd,"rcpt")) x1=2;
    else if (!strcasecmp(cmd,"rset")) x1=3;
    else if (!strcasecmp(cmd,"quit")) x1=4;
    else if (!strcasecmp(cmd,"noop")) x1=5;
    else if (!strcasecmp(cmd,"data")) { x1=6; }
    else if (!strcasecmp(cmd,"___e")) { e0=0; e1=1; x1=7; }
    else if (!strcasecmp(cmd,"___b")) { e3=1; x1=7; }
    else if (!strcasecmp(cmd,"_ba0")) { ll.start_logging(0); x1=7; }
    else if (!strcasecmp(cmd,"_ea0")) { ll.stop_logging(0); x1=7; }
    else if (!strcasecmp(cmd,"_ba1")) { ll.start_logging(1); x1=7; }
    else if (!strcasecmp(cmd,"_ea1")) { ll.stop_logging(1); x1=7; }
    else if (!strcasecmp(cmd,"_ba2")) { ll.start_logging(2); x1=7; }
    else if (!strcasecmp(cmd,"_ea2")) { ll.stop_logging(2); x1=7; }
    else if (!strcasecmp(cmd,"_ba3")) { ll.start_logging(3); x1=7; }
    else if (!strcasecmp(cmd,"_ea3")) { ll.stop_logging(3); x1=7; }
    else if (!strcasecmp(cmd,"__l0")) { ll.loglevel(LL_SILENT); x1=7; }
    else if (!strcasecmp(cmd,"__l1")) { ll.loglevel(LL_STARTEND); x1=7; }
    else if (!strcasecmp(cmd,"__l2")) { ll.loglevel(LL_ACTIONS); x1=7; }
    else x1=7;
}

void z2(int code)
{
    ll.action(2,"   ");
    std::string str;
    switch (code) {
    case 421:
        str = "Service not available, closing transmission channel";
        break;
    case 500:
        str = "Command unrecognized";
        break;
    case 501:
        str = "Syntax error in parameters or arguments";
        break;
    case 503:
        str = "Bad sequence of commands";
        break;
    case 550:
        str = "Requested action not taken: mailbox unavailable";
        break;
    case 553:
        str = "Requested action not taken: mailbox name not allowed";
        break;
    default:
        str = "unknown code";
        break;
    }
#ifdef _TRUE_CONSOLE_
    std::cout << code << " " << str << std::endl ;
#else
    std::cout << code << " " << str << "\r\n";
#endif
    if (code!=221 && code!=421 && code!=354)
        readnew();
}


void z3(int code)
{
    ll.action(3,"     ");
    std::string str;
    switch (code) {
    case 220:
        str = "Service ready";
        break;
    case 221:
        str = "Service closing transmission channel";
        break;
    case 250:
        str = "Requested mail action okay, completed";
        break;
    case 354:
        str = "Start mail input; end with <CRLF>.<CRLF>";
        break;
    default:
        str = "unknown code";
        break;
    }
#ifdef _TRUE_CONSOLE_
    std::cout << code << " " << str << std::endl ;
#else
    //printf("%u %s\r\n",code,str.c_str());
    std::cout << code << " " << str << "\r\n";

#endif
    if (code!=221 && code!=421 && code!=354)
        readnew();
}

void z4()
{
    ll.action(4,"   ");
}

void z5()
{
    ll.action(5,"    ");
#ifdef _TRUE_CONSOLE_
    std::cout << "Author name:" << lp << std::endl
              << "Author domain:" << dm << std::endl;
#endif
}

void z6()
{
    ll.action(6,"    ");
#ifdef _TRUE_CONSOLE_
    std::cout << "Recepient name:" << lp << std::endl
              << "Recepient domain:" << dm << std::endl;
#endif
}

void z7()
{
    ll.action(7,"    ");
}

void z8()
{
    e0=0;
    ll.action(8," ");
}

std::string m="";

void z9()
{
    ll.action(9,"  x2  ");
    m+=x2;
    x3 = x4 = x5 = x6 = 0;
    if (!strcasecmp(m.c_str(),"MAIL")) x3=1;
    if (!strcasecmp(m.c_str(),"RCPT")) x4=1;
    if (!strcasecmp(m.c_str(),"FROM")) x5=1;
    if (!strcasecmp(m.c_str(),"TO")) x6=1;
}

void z10()
{
    ll.action(10," ");
    x3 = x4 = x5 = x6 = 0;
    m="";
}

void z11()
{
    ll.action(11,"      x2");
    x2=cmd[pos];
    pos++;
    if (pos==cmd.length())
        x7= true;
}


void z12()
{
    ll.action(12,"  ");
    lp=""; dm="";
}

void z13()
{
    ll.action(13," x2  ");
    lp+=x2;
    x8 = x2=='.';
}

void z14()
{
    if (x2!='.') {
        ll.action(14,"   ");
        lp+='.';
    }
}

void z15()
{
    ll.action(15," x2  ");
    dm+=x2;
    x8 = x2=='.';
}

void z16()
{
    if (x2!='.') {
        ll.action(16,"   ");
        dm+='.';
    }
}

char curchar;

void z17()
{
#ifndef _TRUE_CONSOLE_
    static char buf[2048]="";
    static bool valid=false;
    static int pos=0;
#endif;
#ifdef _TRUE_CONSOLE_
     static bool cr=false;
     if (cr) {
         curchar='\n';
         cr=false;
     } else {
         curchar = getchar();
         if (curchar=='\n') {
             curchar='\r';
             cr=true;
         }
     }
#else
     if (!valid) {
         cin.getline(buf,2048);
         ll.action(6,buf);
         int p = strlen(buf);
         buf[p]='\n';
         buf[p+1]=0;
         pos=0;
         ll.action(7,buf);
     };
     curchar=buf[pos++];
     valid = buf[pos]!=0;
#endif
     std::string s= curchar=='\r' ? "CR" : curchar=='\n' ? "LF" : std::string("")+curchar;
     ll.action(17,std::string("   [")+s+"]");
     x9=x10=x11=0;
     switch(curchar) {
     case '\r':
         x9=1;
         break;
     case '\n':
         x10=1;
         break;
     case '.':
         x11=1;
         break;
     }
}

void z18()
{
    ll.action(18,"  ");
}

void z19()
{
    ll.action(19," ");
}


void z20()
{
    ll.action(20," CR");
}

void z21()
{
    ll.action(21," LF");
}

void main()
{
    loginit();
    e0=1;
    A0();
    while (y0!=4) {
        A0();
    }
}
