// -*- mode: C++; coding: cp1251 -*-
//
//

#ifndef _SMTP_H_
#define _SMTP_H_

#include <string>
#include "log.h"


#ifdef WIN32
#define strcasecmp _stricmp
#endif

extern int x1;
extern char x2;
extern bool x3;
extern bool x4;
extern bool x5;
extern bool x6;
extern bool x7;
extern bool x8;
extern bool x9;
extern bool x10;
extern bool x11;
extern bool x12;

extern bool e0;
extern bool e1;
extern bool e2;
extern bool e3;

extern int y0;
extern int y1;
extern int y2;
extern int y3;

extern std::string lp;
extern std::string dm;
extern std::string cmd;
extern int pos;
extern std::stringstream out;
extern std::string line;
extern int pos_line;


void z1();
void z2(int code);
void z3(int code);
void z4();void z5();void z6();
void z7();void z8();void z9();
void z10();void z11();void z12();
void z13();void z14();void z15();
void z16();void z17();void z18();
void z19();void z20();void z21();


void A0(); void A1(); void A2(); void A3();

void log_begin(int n, int state);
void log_end(int n, int state);
void loginit();
void log_inv_state(int n, int state);

extern Logger ll;

struct Address {
	Address();
	Address(const std::string&,const std::string&);
	void clear();
	std::string lp;
	std::string dm;
};


inline Address::Address() 
	: lp(""), dm("")
{}
inline Address::Address(const std::string& l, const std::string& d) 
	: lp(l), dm(d)
{}
inline void  Address::clear() { dm=""; lp=""; }


extern std::list<Address> rcpts;
extern Address author;
extern std::string mailtext;


#endif