// Mailinfo.cpp : implementation file
//

#include "stdafx.h"
#include "logger.h"
#include "Mailinfo.h"
#include "..\smtp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Mailinfo dialog


Mailinfo::Mailinfo(CWnd* pParent /*=NULL*/)
	: CDialog(Mailinfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(Mailinfo)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void Mailinfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Mailinfo)
	DDX_Control(pDX, IDC_LIST1, m_rcpts_list);
	DDX_Control(pDX, IDC_EDIT4, m_Text);
	DDX_Control(pDX, IDC_EDIT2, m_from_dm);
	DDX_Control(pDX, IDC_EDIT1, m_from_lp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Mailinfo, CDialog)
	//{{AFX_MSG_MAP(Mailinfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Mailinfo message handlers

BOOL Mailinfo::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_from_lp.SetWindowText(author.lp.c_str());
	m_from_dm.SetWindowText(author.dm.c_str());
	for (std::list<Address>::const_iterator ci=rcpts.begin(); ci!=rcpts.end(); ++ci) {
		m_rcpts_list.AddString((ci->lp+"@"+ci->dm).c_str());
	
	}
	m_Text.SetWindowText(mailtext.c_str());
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
