// loggerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "logger.h"
#include "loggerDlg.h"
#include "..\smtp.h"
#include "Mailinfo.h"
#include "A0vars.h"
#include "A1vars.h"
#include "A2vars.h"
#include "A3vars.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLoggerDlg dialog

CLoggerDlg::CLoggerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLoggerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLoggerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	//m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
}

void CLoggerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLoggerDlg)
	DDX_Control(pDX, IDC_CHECK6, m_shtdwn);
	DDX_Control(pDX, IDC_EDIT3, m_from_lp);
	DDX_Control(pDX, IDC_EDIT2, m_from_dm);
	DDX_Control(pDX, IDC_EDIT4, m_Text);
	DDX_Control(pDX, IDC_LIST2, m_rcpts);
	DDX_Control(pDX, IDC_CHECK1, m_connected);
	DDX_Control(pDX, IDC_LIST3, m_out);
	DDX_Control(pDX, IDC_EDIT1, m_cmd);
	DDX_Control(pDX, IDC_CHECK5, a3log);
	DDX_Control(pDX, IDC_CHECK4, a2log);
	DDX_Control(pDX, IDC_CHECK3, a1log);
	DDX_Control(pDX, IDC_CHECK2, a0log);
	DDX_Control(pDX, IDC_LIST1, loglist);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLoggerDlg, CDialog)
	//{{AFX_MSG_MAP(CLoggerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButtonExit)
	ON_LBN_SELCHANGE(IDC_LIST3, OnSelchangeList3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CLoggerDlg message handlers

BOOL CLoggerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	loginit();
	a0log.SetCheck(true);
	a1log.SetCheck(true);
	a2log.SetCheck(true);
	a3log.SetCheck(true);
	CButton *radio=(CButton *) GetDlgItem(IDC_RADIO3);
	radio->SetCheck(true);
	

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLoggerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLoggerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLoggerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLoggerDlg::RefreshLog()
{
	char buf[1024];
	while (!ll.stream().eof()) {
		ll.stream().getline(buf,1024);
		if (buf[0]) 
			loglist.InsertString(loglist.GetCount(),buf);
	}
	ll.stream().clear();
	loglist.SetCaretIndex(loglist.GetCount());

	while (!out.eof()) {
		out.getline(buf,1024);
		if (buf[0]) 
			m_out.InsertString(m_out.GetCount(),buf);
	}
	out.clear();
	m_out.SetCaretIndex(m_out.GetCount());
	//m_out.SetCurSel(m_out.GetCount());
	//m_out.SetScrollPos(SB_VERT,m_out.GetCount());
	m_from_lp.SetWindowText(author.lp.c_str());
	m_from_dm.SetWindowText(author.dm.c_str());
	m_rcpts.ResetContent();
	for (std::list<Address>::const_iterator ci=rcpts.begin(); ci!=rcpts.end(); ++ci) {
		m_rcpts.AddString((ci->lp+"@"+ci->dm).c_str());
	
	}
	m_Text.SetWindowText(mailtext.c_str());

}


void CLoggerDlg::OnButton3() 
{
	e3=1;
	A0();
	RefreshLog();
}


void CLoggerDlg::OnRadio2() 
{
	ll.loglevel(LL_SILENT);
	RefreshLog();
}

void CLoggerDlg::OnRadio3() 
{
	ll.loglevel(LL_STARTEND);
	RefreshLog();
}

void CLoggerDlg::OnRadio4() 
{
	ll.loglevel(LL_ACTIONS);
	RefreshLog();
}

void CLoggerDlg::OnCheck2() 
{
	if (!a0log.GetCheck())
		ll.stop_logging(0);
	else 
		ll.start_logging(0);
	RefreshLog();	
}

void CLoggerDlg::OnCheck3() 
{
	if (!a1log.GetCheck())
		ll.stop_logging(1);
	else 
		ll.start_logging(1);
	RefreshLog();	
}

void CLoggerDlg::OnCheck4() 
{
	if (!a2log.GetCheck())
		ll.stop_logging(2);
	else 
		ll.start_logging(2);
	RefreshLog();	
}

void CLoggerDlg::OnCheck5() 
{
	if (!a3log.GetCheck())
		ll.stop_logging(3);
	else 
		ll.start_logging(3);
	RefreshLog();	
}



void CLoggerDlg::OnChangeEdit1() 
{
	char *buf=new char[m_cmd.GetWindowTextLength()+1];
	m_cmd.GetWindowText(buf,m_cmd.GetWindowTextLength()+1);
	if (x1==6 && y0==3) {
		if (buf[strlen(buf)-1]=='\n') {
			buf[strlen(buf)-2]=0;
			line=buf;
			pos_line=-1;
			line+="\r\n";
			z17();
			while (pos_line!=line.length() && y3!=6)
				A0();
			if (y3==6) 
				x1=7;
			m_out.InsertString(m_out.GetCount(),buf);
			RefreshLog();
			m_cmd.SetWindowText("");
		}
		
	} else 	
	if (buf[strlen(buf)-1]=='\n' && !(x1==6 && y0==3)) {
		buf[strlen(buf)-2]=0;
		cmd=buf;
	    x1=7;
		pos=0;
		x7=0;
		x2=buf[0];
		m_out.InsertString(m_out.GetCount(),cmd.c_str());
		if (cmd.length()<4)
			x1=7;
		std::string cmd_str=cmd.substr(0,4);
		const char* cmd = cmd_str.c_str();
		if (!strcasecmp(cmd,"helo")) x1=0;
		else if (!strcasecmp(cmd,"mail")) x1=1;
		else if (!strcasecmp(cmd,"rcpt")) x1=2;
		else if (!strcasecmp(cmd,"rset")) x1=3;
		else if (!strcasecmp(cmd,"quit")) x1=4;
		else if (!strcasecmp(cmd,"noop")) x1=5;
		else if (!strcasecmp(cmd,"data")) { x1=6; A0(); }
		else x1=7;
		x12=false;
		while (!x12 && y0!=4 && !(x1==6 && y0==3)) 
			A0();
		RefreshLog();	
		m_cmd.SetWindowText("");
		m_connected.SetCheck(y0!=4);
	} 
	delete [] buf;

}

void CLoggerDlg::OnCheck1() 
{
	// TODO: Add your control notification handler code here
	if (!e3) {
		e0=m_connected.GetCheck()!=0;
		e1=!e0;
		A0();
		RefreshLog();
	} else {
		m_connected.SetCheck(0);
	}
}

void CLoggerDlg::OnOK()
{
}


void CLoggerDlg::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	CDialog::OnClose();
}


void CLoggerDlg::OnButton1() 
{
}

void CLoggerDlg::OnButtonExit() 
{
	CDialog::DestroyWindow();
}


void CLoggerDlg::OnSelchangeList3() 
{
	// TODO: Add your control notification handler code here
}

void CLoggerDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	A0vars a0v;
	a0v.DoModal();
	
}

void CLoggerDlg::OnButton5() 
{
	A1vars a1v;
	a1v.DoModal();
	
}

void CLoggerDlg::OnButton6() 
{
	A2vars a2v;
	a2v.DoModal();	
}

void CLoggerDlg::OnButton7() 
{
	A3vars a3v;
	a3v.DoModal();	
}

void CLoggerDlg::OnCheck6() 
{
	e3=m_shtdwn.GetCheck()!=0;
	A0();
	e0=0;
	e1=1;
	m_connected.SetCheck(e0);
	RefreshLog();
	
}
